// 004 u_ib_dbx_create_table_pk
// 15 oct 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ib_dbx_create_table_pk;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  DBXpress, FMTBcd, SqlExpr
  , IBDatabase
  ;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    create_table_with_primary_key_: TButton;
    drop_table_: TButton;
    Panel1: TPanel;
    Memo1: TMemo;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    procedure FormCreate(Sender: TObject);
    procedure create_table_with_primary_key_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

{$R *.DFM}


    // k_connection_string= 127.0.0.1:C:\programs\interbase\data\Institut_Pascal.GDB

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.create_table_with_primary_key_Click(Sender: TObject);
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('CREATE TABLE formations');
            Add('  ('
                +'    f_numero INTEGER NOT NULL PRIMARY KEY,');
            Add('     f_nom CHAR(23),');
            Add('     f_jours SMALLINT,');
            Add('     f_prix NUMERIC(5, 2)');
            // Add(',    CONSTRAINT xxx PRIMARY KEY (f_id, f_numero)
            // Add(',    CONSTRAINT yyy FOREIGN KEY (f_numero) REFERENCES article (a_id)
            // Add(',    Add(',   CHECK (f_numero> f_id)');
            Add('  )');
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            ExecSql;

            display('  ok');
          except
            on e: Exception do
              begin
                display('  *** pb_create '+ e.Message);
              end;
          end;
        end; // with SqlQuery1
      end; // create_table_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        with SQLQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('DROP TABLE formations');
            display_strings(Sql);

            Try
              ExecSql;
              display('  ok');
            except
              on e: Exception do
                display('  *** pb '+ e.Message);
            end;
          end; // with Sql
        end; // with SQLQuery1
      end; // drop_table_Click

    end.


